/**
 * output package name
 */
package com.kingdee.eas.custom.lxsq.client;

import org.apache.log4j.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.*;
import javax.swing.BorderFactory;
import javax.swing.event.*;
import javax.swing.KeyStroke;

import com.kingdee.bos.ctrl.swing.*;
import com.kingdee.bos.ctrl.kdf.table.*;
import com.kingdee.bos.ctrl.kdf.data.event.*;
import com.kingdee.bos.dao.*;
import com.kingdee.bos.dao.query.*;
import com.kingdee.bos.metadata.*;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.ui.face.*;
import com.kingdee.bos.ui.util.ResourceBundleHelper;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.util.enums.EnumUtils;
import com.kingdee.bos.ui.face.UIRuleUtil;
import com.kingdee.bos.ctrl.swing.event.*;
import com.kingdee.bos.ctrl.kdf.table.event.*;
import com.kingdee.bos.ctrl.extendcontrols.*;
import com.kingdee.bos.ctrl.kdf.util.render.*;
import com.kingdee.bos.ui.face.IItemAction;
import com.kingdee.eas.framework.batchHandler.RequestContext;
import com.kingdee.bos.ui.util.IUIActionPostman;
import com.kingdee.bos.appframework.client.servicebinding.ActionProxyFactory;
import com.kingdee.bos.appframework.uistatemanage.ActionStateConst;
import com.kingdee.bos.appframework.validator.ValidateHelper;
import com.kingdee.bos.appframework.uip.UINavigator;


/**
 * output class name
 */
public abstract class AbstractProjectApplicationEditUI extends com.kingdee.eas.xr.client.XRBillBaseEditUI
{
    private static final Logger logger = CoreUIObject.getLogger(AbstractProjectApplicationEditUI.class);
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contCreator;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contCreateTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contLastUpdateUser;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contLastUpdateTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contCU;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contNumber;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contBizDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contDescription;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contAuditor;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contStatus;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contBizStatus;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contAuditTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer conttitle;
    protected com.kingdee.bos.ctrl.swing.KDCheckBox chkemergency;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contprojectNam;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contpreDepartment;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contpreCompany;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contprePerson;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contbudget;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contstartTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contendTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contattributeCompany;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contreason;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contcomment;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contoverTime;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtCreator;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkCreateTime;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtLastUpdateUser;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkLastUpdateTime;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtCU;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtNumber;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkBizDate;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtDescription;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtAuditor;
    protected com.kingdee.bos.ctrl.swing.KDComboBox comboStatus;
    protected com.kingdee.bos.ctrl.swing.KDComboBox comboBizStatus;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkAuditTime;
    protected com.kingdee.bos.ctrl.swing.KDTextField txttitle;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtprojectNam;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtpreDepartment;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtpreCompany;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtprePerson;
    protected com.kingdee.bos.ctrl.swing.KDFormattedTextField txtbudget;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkstartTime;
    protected com.kingdee.bos.ctrl.swing.KDTimePicker endTime;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtattributeCompany;
    protected com.kingdee.bos.ctrl.swing.KDScrollPane scrollPanereason;
    protected com.kingdee.bos.ctrl.swing.KDTextArea txtreason;
    protected com.kingdee.bos.ctrl.swing.KDScrollPane scrollPanecomment;
    protected com.kingdee.bos.ctrl.swing.KDTextArea txtcomment;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkoverTime;
    protected com.kingdee.eas.custom.lxsq.ProjectApplicationInfo editData = null;
    /**
     * output class constructor
     */
    public AbstractProjectApplicationEditUI() throws Exception
    {
        super();
        this.defaultObjectName = "editData";
        jbInit();
        
        initUIP();
    }

    /**
     * output jbInit method
     */
    private void jbInit() throws Exception
    {
        this.resHelper = new ResourceBundleHelper(AbstractProjectApplicationEditUI.class.getName());
        this.setUITitle(resHelper.getString("this.title"));
        //actionSubmit
        String _tempStr = null;
        actionSubmit.setEnabled(true);
        actionSubmit.setDaemonRun(false);

        actionSubmit.putValue(ItemAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke("ctrl S"));
        _tempStr = resHelper.getString("ActionSubmit.SHORT_DESCRIPTION");
        actionSubmit.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionSubmit.LONG_DESCRIPTION");
        actionSubmit.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionSubmit.NAME");
        actionSubmit.putValue(ItemAction.NAME, _tempStr);
        this.actionSubmit.setBindWorkFlow(true);
        this.actionSubmit.setExtendProperty("canForewarn", "true");
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.PermissionService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.NetFunctionService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.UserMonitorService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.ForewarnService());
        //actionUnAudit
        actionUnAudit.setEnabled(true);
        actionUnAudit.setDaemonRun(false);

        _tempStr = resHelper.getString("ActionUnAudit.SHORT_DESCRIPTION");
        actionUnAudit.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionUnAudit.LONG_DESCRIPTION");
        actionUnAudit.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionUnAudit.NAME");
        actionUnAudit.putValue(ItemAction.NAME, _tempStr);
        this.actionUnAudit.setBindWorkFlow(true);
         this.actionUnAudit.addService(new com.kingdee.eas.framework.client.service.PermissionService());
        this.contCreator = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contCreateTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contLastUpdateUser = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contLastUpdateTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contCU = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contNumber = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contBizDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contDescription = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contAuditor = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contStatus = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contBizStatus = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contAuditTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.conttitle = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.chkemergency = new com.kingdee.bos.ctrl.swing.KDCheckBox();
        this.contprojectNam = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contpreDepartment = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contpreCompany = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contprePerson = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contbudget = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contstartTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contendTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contattributeCompany = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contreason = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contcomment = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contoverTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.prmtCreator = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.pkCreateTime = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.prmtLastUpdateUser = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.pkLastUpdateTime = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.prmtCU = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.txtNumber = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.pkBizDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.txtDescription = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.prmtAuditor = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.comboStatus = new com.kingdee.bos.ctrl.swing.KDComboBox();
        this.comboBizStatus = new com.kingdee.bos.ctrl.swing.KDComboBox();
        this.pkAuditTime = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.txttitle = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtprojectNam = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.prmtpreDepartment = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.prmtpreCompany = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.prmtprePerson = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.txtbudget = new com.kingdee.bos.ctrl.swing.KDFormattedTextField();
        this.pkstartTime = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.endTime = new com.kingdee.bos.ctrl.swing.KDTimePicker();
        this.prmtattributeCompany = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.scrollPanereason = new com.kingdee.bos.ctrl.swing.KDScrollPane();
        this.txtreason = new com.kingdee.bos.ctrl.swing.KDTextArea();
        this.scrollPanecomment = new com.kingdee.bos.ctrl.swing.KDScrollPane();
        this.txtcomment = new com.kingdee.bos.ctrl.swing.KDTextArea();
        this.pkoverTime = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.contCreator.setName("contCreator");
        this.contCreateTime.setName("contCreateTime");
        this.contLastUpdateUser.setName("contLastUpdateUser");
        this.contLastUpdateTime.setName("contLastUpdateTime");
        this.contCU.setName("contCU");
        this.contNumber.setName("contNumber");
        this.contBizDate.setName("contBizDate");
        this.contDescription.setName("contDescription");
        this.contAuditor.setName("contAuditor");
        this.contStatus.setName("contStatus");
        this.contBizStatus.setName("contBizStatus");
        this.contAuditTime.setName("contAuditTime");
        this.conttitle.setName("conttitle");
        this.chkemergency.setName("chkemergency");
        this.contprojectNam.setName("contprojectNam");
        this.contpreDepartment.setName("contpreDepartment");
        this.contpreCompany.setName("contpreCompany");
        this.contprePerson.setName("contprePerson");
        this.contbudget.setName("contbudget");
        this.contstartTime.setName("contstartTime");
        this.contendTime.setName("contendTime");
        this.contattributeCompany.setName("contattributeCompany");
        this.contreason.setName("contreason");
        this.contcomment.setName("contcomment");
        this.contoverTime.setName("contoverTime");
        this.prmtCreator.setName("prmtCreator");
        this.pkCreateTime.setName("pkCreateTime");
        this.prmtLastUpdateUser.setName("prmtLastUpdateUser");
        this.pkLastUpdateTime.setName("pkLastUpdateTime");
        this.prmtCU.setName("prmtCU");
        this.txtNumber.setName("txtNumber");
        this.pkBizDate.setName("pkBizDate");
        this.txtDescription.setName("txtDescription");
        this.prmtAuditor.setName("prmtAuditor");
        this.comboStatus.setName("comboStatus");
        this.comboBizStatus.setName("comboBizStatus");
        this.pkAuditTime.setName("pkAuditTime");
        this.txttitle.setName("txttitle");
        this.txtprojectNam.setName("txtprojectNam");
        this.prmtpreDepartment.setName("prmtpreDepartment");
        this.prmtpreCompany.setName("prmtpreCompany");
        this.prmtprePerson.setName("prmtprePerson");
        this.txtbudget.setName("txtbudget");
        this.pkstartTime.setName("pkstartTime");
        this.endTime.setName("endTime");
        this.prmtattributeCompany.setName("prmtattributeCompany");
        this.scrollPanereason.setName("scrollPanereason");
        this.txtreason.setName("txtreason");
        this.scrollPanecomment.setName("scrollPanecomment");
        this.txtcomment.setName("txtcomment");
        this.pkoverTime.setName("pkoverTime");
        // CoreUI
        // contCreator		
        this.contCreator.setBoundLabelText(resHelper.getString("contCreator.boundLabelText"));		
        this.contCreator.setBoundLabelLength(100);		
        this.contCreator.setBoundLabelUnderline(true);
        // contCreateTime		
        this.contCreateTime.setBoundLabelText(resHelper.getString("contCreateTime.boundLabelText"));		
        this.contCreateTime.setBoundLabelLength(100);		
        this.contCreateTime.setBoundLabelUnderline(true);
        // contLastUpdateUser		
        this.contLastUpdateUser.setBoundLabelText(resHelper.getString("contLastUpdateUser.boundLabelText"));		
        this.contLastUpdateUser.setBoundLabelLength(100);		
        this.contLastUpdateUser.setBoundLabelUnderline(true);
        // contLastUpdateTime		
        this.contLastUpdateTime.setBoundLabelText(resHelper.getString("contLastUpdateTime.boundLabelText"));		
        this.contLastUpdateTime.setBoundLabelLength(100);		
        this.contLastUpdateTime.setBoundLabelUnderline(true);
        // contCU		
        this.contCU.setBoundLabelText(resHelper.getString("contCU.boundLabelText"));		
        this.contCU.setBoundLabelLength(100);		
        this.contCU.setBoundLabelUnderline(true);		
        this.contCU.setEnabled(false);		
        this.contCU.setVisible(false);
        // contNumber		
        this.contNumber.setBoundLabelText(resHelper.getString("contNumber.boundLabelText"));		
        this.contNumber.setBoundLabelLength(100);		
        this.contNumber.setBoundLabelUnderline(true);
        // contBizDate		
        this.contBizDate.setBoundLabelText(resHelper.getString("contBizDate.boundLabelText"));		
        this.contBizDate.setBoundLabelLength(100);		
        this.contBizDate.setBoundLabelUnderline(true);
        // contDescription		
        this.contDescription.setBoundLabelText(resHelper.getString("contDescription.boundLabelText"));		
        this.contDescription.setBoundLabelLength(100);		
        this.contDescription.setBoundLabelUnderline(true);		
        this.contDescription.setVisible(false);
        // contAuditor		
        this.contAuditor.setBoundLabelText(resHelper.getString("contAuditor.boundLabelText"));		
        this.contAuditor.setBoundLabelLength(100);		
        this.contAuditor.setBoundLabelUnderline(true);
        // contStatus		
        this.contStatus.setBoundLabelText(resHelper.getString("contStatus.boundLabelText"));		
        this.contStatus.setBoundLabelLength(100);		
        this.contStatus.setBoundLabelUnderline(true);		
        this.contStatus.setEnabled(false);
        // contBizStatus		
        this.contBizStatus.setBoundLabelText(resHelper.getString("contBizStatus.boundLabelText"));		
        this.contBizStatus.setBoundLabelLength(100);		
        this.contBizStatus.setBoundLabelUnderline(true);		
        this.contBizStatus.setEnabled(false);		
        this.contBizStatus.setVisible(false);
        // contAuditTime		
        this.contAuditTime.setBoundLabelText(resHelper.getString("contAuditTime.boundLabelText"));		
        this.contAuditTime.setBoundLabelLength(100);		
        this.contAuditTime.setBoundLabelUnderline(true);
        // conttitle		
        this.conttitle.setBoundLabelText(resHelper.getString("conttitle.boundLabelText"));		
        this.conttitle.setBoundLabelLength(100);		
        this.conttitle.setBoundLabelUnderline(true);		
        this.conttitle.setVisible(true);
        // chkemergency		
        this.chkemergency.setText(resHelper.getString("chkemergency.text"));		
        this.chkemergency.setVisible(true);		
        this.chkemergency.setHorizontalAlignment(2);
        // contprojectNam		
        this.contprojectNam.setBoundLabelText(resHelper.getString("contprojectNam.boundLabelText"));		
        this.contprojectNam.setBoundLabelLength(100);		
        this.contprojectNam.setBoundLabelUnderline(true);		
        this.contprojectNam.setVisible(true);
        // contpreDepartment		
        this.contpreDepartment.setBoundLabelText(resHelper.getString("contpreDepartment.boundLabelText"));		
        this.contpreDepartment.setBoundLabelLength(100);		
        this.contpreDepartment.setBoundLabelUnderline(true);		
        this.contpreDepartment.setVisible(true);
        // contpreCompany		
        this.contpreCompany.setBoundLabelText(resHelper.getString("contpreCompany.boundLabelText"));		
        this.contpreCompany.setBoundLabelLength(100);		
        this.contpreCompany.setBoundLabelUnderline(true);		
        this.contpreCompany.setVisible(true);
        // contprePerson		
        this.contprePerson.setBoundLabelText(resHelper.getString("contprePerson.boundLabelText"));		
        this.contprePerson.setBoundLabelLength(100);		
        this.contprePerson.setBoundLabelUnderline(true);		
        this.contprePerson.setVisible(true);
        // contbudget		
        this.contbudget.setBoundLabelText(resHelper.getString("contbudget.boundLabelText"));		
        this.contbudget.setBoundLabelLength(100);		
        this.contbudget.setBoundLabelUnderline(true);		
        this.contbudget.setVisible(true);
        // contstartTime		
        this.contstartTime.setBoundLabelText(resHelper.getString("contstartTime.boundLabelText"));		
        this.contstartTime.setBoundLabelLength(100);		
        this.contstartTime.setBoundLabelUnderline(true);		
        this.contstartTime.setVisible(true);
        // contendTime		
        this.contendTime.setBoundLabelText(resHelper.getString("contendTime.boundLabelText"));		
        this.contendTime.setBoundLabelLength(100);		
        this.contendTime.setBoundLabelUnderline(true);		
        this.contendTime.setVisible(true);
        // contattributeCompany		
        this.contattributeCompany.setBoundLabelText(resHelper.getString("contattributeCompany.boundLabelText"));		
        this.contattributeCompany.setBoundLabelLength(100);		
        this.contattributeCompany.setBoundLabelUnderline(true);		
        this.contattributeCompany.setVisible(true);
        // contreason		
        this.contreason.setBoundLabelText(resHelper.getString("contreason.boundLabelText"));		
        this.contreason.setBoundLabelLength(100);		
        this.contreason.setBoundLabelUnderline(true);		
        this.contreason.setVisible(true);
        // contcomment		
        this.contcomment.setBoundLabelText(resHelper.getString("contcomment.boundLabelText"));		
        this.contcomment.setBoundLabelLength(100);		
        this.contcomment.setBoundLabelUnderline(true);		
        this.contcomment.setVisible(true);
        // contoverTime		
        this.contoverTime.setBoundLabelText(resHelper.getString("contoverTime.boundLabelText"));		
        this.contoverTime.setBoundLabelLength(100);		
        this.contoverTime.setBoundLabelUnderline(true);		
        this.contoverTime.setVisible(true);
        // prmtCreator		
        this.prmtCreator.setEnabled(false);		
        this.prmtCreator.setCommitFormat("$name$");		
        this.prmtCreator.setEditFormat("$name$");		
        this.prmtCreator.setDisplayFormat("$name$");
        // pkCreateTime		
        this.pkCreateTime.setTimeEnabled(true);		
        this.pkCreateTime.setEnabled(false);
        // prmtLastUpdateUser		
        this.prmtLastUpdateUser.setEnabled(false);		
        this.prmtLastUpdateUser.setDisplayFormat("$name$");		
        this.prmtLastUpdateUser.setEditFormat("$name$");		
        this.prmtLastUpdateUser.setCommitFormat("$name$");
        // pkLastUpdateTime		
        this.pkLastUpdateTime.setTimeEnabled(true);		
        this.pkLastUpdateTime.setEnabled(false);
        // prmtCU		
        this.prmtCU.setEnabled(false);
        // txtNumber		
        this.txtNumber.setRequired(true);
        // pkBizDate
        // txtDescription
        // prmtAuditor		
        this.prmtAuditor.setEnabled(false);		
        this.prmtAuditor.setCommitFormat("$name$");		
        this.prmtAuditor.setDisplayFormat("$name$");		
        this.prmtAuditor.setEditFormat("$name$");
        // comboStatus		
        this.comboStatus.addItems(EnumUtils.getEnumList("com.kingdee.eas.xr.app.XRBillStatusEnum").toArray());		
        this.comboStatus.setEnabled(false);
        // comboBizStatus		
        this.comboBizStatus.addItems(EnumUtils.getEnumList("com.kingdee.eas.xr.app.XRBizActionEnum").toArray());		
        this.comboBizStatus.setEnabled(false);		
        this.comboBizStatus.setVisible(false);
        // pkAuditTime		
        this.pkAuditTime.setTimeEnabled(true);		
        this.pkAuditTime.setEnabled(false);
        // txttitle		
        this.txttitle.setVisible(true);		
        this.txttitle.setHorizontalAlignment(2);		
        this.txttitle.setMaxLength(255);		
        this.txttitle.setRequired(true);
        // txtprojectNam		
        this.txtprojectNam.setVisible(true);		
        this.txtprojectNam.setHorizontalAlignment(2);		
        this.txtprojectNam.setMaxLength(255);		
        this.txtprojectNam.setRequired(true);
        // prmtpreDepartment		
        this.prmtpreDepartment.setQueryInfo("com.kingdee.eas.basedata.org.app.AdminItemQuery");		
        this.prmtpreDepartment.setVisible(true);		
        this.prmtpreDepartment.setEditable(true);		
        this.prmtpreDepartment.setDisplayFormat("$name$");		
        this.prmtpreDepartment.setEditFormat("$number$");		
        this.prmtpreDepartment.setCommitFormat("$number$");		
        this.prmtpreDepartment.setRequired(false);
        // prmtpreCompany		
        this.prmtpreCompany.setQueryInfo("com.kingdee.eas.basedata.org.app.CompanyOrgUnitQuery");		
        this.prmtpreCompany.setVisible(true);		
        this.prmtpreCompany.setEditable(true);		
        this.prmtpreCompany.setDisplayFormat("$name$");		
        this.prmtpreCompany.setEditFormat("$number$");		
        this.prmtpreCompany.setCommitFormat("$number$");		
        this.prmtpreCompany.setRequired(false);
        // prmtprePerson		
        this.prmtprePerson.setQueryInfo("com.kingdee.eas.basedata.person.app.PersonQuery");		
        this.prmtprePerson.setVisible(true);		
        this.prmtprePerson.setEditable(true);		
        this.prmtprePerson.setDisplayFormat("$name$");		
        this.prmtprePerson.setEditFormat("$number$");		
        this.prmtprePerson.setCommitFormat("$number$");		
        this.prmtprePerson.setRequired(false);
        // txtbudget		
        this.txtbudget.setVisible(true);		
        this.txtbudget.setHorizontalAlignment(2);		
        this.txtbudget.setDataType(1);		
        this.txtbudget.setSupportedEmpty(true);		
        this.txtbudget.setMinimumValue( new java.math.BigDecimal("-1.0E18"));		
        this.txtbudget.setMaximumValue( new java.math.BigDecimal("1.0E18"));		
        this.txtbudget.setPrecision(2);		
        this.txtbudget.setRequired(true);
        // pkstartTime		
        this.pkstartTime.setVisible(true);		
        this.pkstartTime.setRequired(false);
        // endTime		
        this.endTime.setVisible(true);
        // prmtattributeCompany		
        this.prmtattributeCompany.setQueryInfo("com.kingdee.eas.basedata.org.app.CompanyOrgUnitQuery");		
        this.prmtattributeCompany.setVisible(true);		
        this.prmtattributeCompany.setEditable(true);		
        this.prmtattributeCompany.setDisplayFormat("$name$");		
        this.prmtattributeCompany.setEditFormat("$number$");		
        this.prmtattributeCompany.setCommitFormat("$number$");		
        this.prmtattributeCompany.setRequired(false);
        // scrollPanereason
        // txtreason		
        this.txtreason.setVisible(true);		
        this.txtreason.setRequired(true);		
        this.txtreason.setMaxLength(2000);
        // scrollPanecomment
        // txtcomment		
        this.txtcomment.setVisible(true);		
        this.txtcomment.setRequired(false);		
        this.txtcomment.setMaxLength(2000);
        // pkoverTime		
        this.pkoverTime.setVisible(true);		
        this.pkoverTime.setRequired(false);
        this.setFocusTraversalPolicy(new com.kingdee.bos.ui.UIFocusTraversalPolicy(new java.awt.Component[] {txttitle,prmtprePerson,prmtpreDepartment,prmtpreCompany,chkemergency,txtprojectNam,txtbudget,pkstartTime,endTime,prmtattributeCompany,txtreason,txtcomment,pkoverTime}));
        this.setFocusCycleRoot(true);
		//Register control's property binding
		registerBindings();
		registerUIState();


    }

	public com.kingdee.bos.ctrl.swing.KDToolBar[] getUIMultiToolBar(){
		java.util.List list = new java.util.ArrayList();
		com.kingdee.bos.ctrl.swing.KDToolBar[] bars = super.getUIMultiToolBar();
		if (bars != null) {
			list.addAll(java.util.Arrays.asList(bars));
		}
		return (com.kingdee.bos.ctrl.swing.KDToolBar[])list.toArray(new com.kingdee.bos.ctrl.swing.KDToolBar[list.size()]);
	}




    /**
     * output initUIContentLayout method
     */
    public void initUIContentLayout()
    {
        this.setBounds(new Rectangle(10, 10, 1013, 629));
        this.setLayout(new KDLayout());
        this.putClientProperty("OriginalBounds", new Rectangle(10, 10, 1013, 629));
        contCreator.setBounds(new Rectangle(40, 470, 270, 19));
        this.add(contCreator, new KDLayout.Constraints(40, 470, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contCreateTime.setBounds(new Rectangle(40, 502, 270, 19));
        this.add(contCreateTime, new KDLayout.Constraints(40, 502, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contLastUpdateUser.setBounds(new Rectangle(348, 470, 270, 19));
        this.add(contLastUpdateUser, new KDLayout.Constraints(348, 470, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contLastUpdateTime.setBounds(new Rectangle(348, 502, 270, 19));
        this.add(contLastUpdateTime, new KDLayout.Constraints(348, 502, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contCU.setBounds(new Rectangle(930, 377, 270, 19));
        this.add(contCU, new KDLayout.Constraints(930, 377, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contNumber.setBounds(new Rectangle(35, 15, 270, 19));
        this.add(contNumber, new KDLayout.Constraints(35, 15, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contBizDate.setBounds(new Rectangle(658, 15, 270, 19));
        this.add(contBizDate, new KDLayout.Constraints(658, 15, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contDescription.setBounds(new Rectangle(925, 401, 270, 19));
        this.add(contDescription, new KDLayout.Constraints(925, 401, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contAuditor.setBounds(new Rectangle(660, 470, 270, 19));
        this.add(contAuditor, new KDLayout.Constraints(660, 470, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contStatus.setBounds(new Rectangle(35, 139, 270, 19));
        this.add(contStatus, new KDLayout.Constraints(35, 139, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contBizStatus.setBounds(new Rectangle(917, 427, 270, 19));
        this.add(contBizStatus, new KDLayout.Constraints(917, 427, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contAuditTime.setBounds(new Rectangle(660, 502, 270, 19));
        this.add(contAuditTime, new KDLayout.Constraints(660, 502, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        conttitle.setBounds(new Rectangle(346, 15, 270, 19));
        this.add(conttitle, new KDLayout.Constraints(346, 15, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        chkemergency.setBounds(new Rectangle(658, 77, 270, 19));
        this.add(chkemergency, new KDLayout.Constraints(658, 77, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contprojectNam.setBounds(new Rectangle(35, 77, 270, 19));
        this.add(contprojectNam, new KDLayout.Constraints(35, 77, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contpreDepartment.setBounds(new Rectangle(346, 46, 270, 19));
        this.add(contpreDepartment, new KDLayout.Constraints(346, 46, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contpreCompany.setBounds(new Rectangle(658, 46, 270, 19));
        this.add(contpreCompany, new KDLayout.Constraints(658, 46, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contprePerson.setBounds(new Rectangle(35, 46, 270, 19));
        this.add(contprePerson, new KDLayout.Constraints(35, 46, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contbudget.setBounds(new Rectangle(346, 77, 270, 19));
        this.add(contbudget, new KDLayout.Constraints(346, 77, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contstartTime.setBounds(new Rectangle(35, 108, 270, 19));
        this.add(contstartTime, new KDLayout.Constraints(35, 108, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contendTime.setBounds(new Rectangle(913, 447, 270, 19));
        this.add(contendTime, new KDLayout.Constraints(913, 447, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contattributeCompany.setBounds(new Rectangle(658, 109, 270, 19));
        this.add(contattributeCompany, new KDLayout.Constraints(658, 109, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contreason.setBounds(new Rectangle(36, 168, 891, 175));
        this.add(contreason, new KDLayout.Constraints(36, 168, 891, 175, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT));
        contcomment.setBounds(new Rectangle(36, 354, 891, 101));
        this.add(contcomment, new KDLayout.Constraints(36, 354, 891, 101, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT));
        contoverTime.setBounds(new Rectangle(346, 109, 270, 19));
        this.add(contoverTime, new KDLayout.Constraints(346, 109, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        //contCreator
        contCreator.setBoundEditor(prmtCreator);
        //contCreateTime
        contCreateTime.setBoundEditor(pkCreateTime);
        //contLastUpdateUser
        contLastUpdateUser.setBoundEditor(prmtLastUpdateUser);
        //contLastUpdateTime
        contLastUpdateTime.setBoundEditor(pkLastUpdateTime);
        //contCU
        contCU.setBoundEditor(prmtCU);
        //contNumber
        contNumber.setBoundEditor(txtNumber);
        //contBizDate
        contBizDate.setBoundEditor(pkBizDate);
        //contDescription
        contDescription.setBoundEditor(txtDescription);
        //contAuditor
        contAuditor.setBoundEditor(prmtAuditor);
        //contStatus
        contStatus.setBoundEditor(comboStatus);
        //contBizStatus
        contBizStatus.setBoundEditor(comboBizStatus);
        //contAuditTime
        contAuditTime.setBoundEditor(pkAuditTime);
        //conttitle
        conttitle.setBoundEditor(txttitle);
        //contprojectNam
        contprojectNam.setBoundEditor(txtprojectNam);
        //contpreDepartment
        contpreDepartment.setBoundEditor(prmtpreDepartment);
        //contpreCompany
        contpreCompany.setBoundEditor(prmtpreCompany);
        //contprePerson
        contprePerson.setBoundEditor(prmtprePerson);
        //contbudget
        contbudget.setBoundEditor(txtbudget);
        //contstartTime
        contstartTime.setBoundEditor(pkstartTime);
        //contendTime
        contendTime.setBoundEditor(endTime);
        //contattributeCompany
        contattributeCompany.setBoundEditor(prmtattributeCompany);
        //contreason
        contreason.setBoundEditor(scrollPanereason);
        //scrollPanereason
        scrollPanereason.getViewport().add(txtreason, null);
        //contcomment
        contcomment.setBoundEditor(scrollPanecomment);
        //scrollPanecomment
        scrollPanecomment.getViewport().add(txtcomment, null);
        //contoverTime
        contoverTime.setBoundEditor(pkoverTime);

    }


    /**
     * output initUIMenuBarLayout method
     */
    public void initUIMenuBarLayout()
    {
        this.menuBar.add(menuFile);
        this.menuBar.add(menuEdit);
        this.menuBar.add(MenuService);
        this.menuBar.add(menuView);
        this.menuBar.add(menuBiz);
        this.menuBar.add(menuTable1);
        this.menuBar.add(menuTool);
        this.menuBar.add(menuWorkflow);
        this.menuBar.add(menuHelp);
        //menuFile
        menuFile.add(menuItemAddNew);
        menuFile.add(kDSeparator1);
        menuFile.add(menuItemCloudFeed);
        menuFile.add(menuItemSave);
        menuFile.add(menuItemCloudScreen);
        menuFile.add(menuItemSubmit);
        menuFile.add(menuItemCloudShare);
        menuFile.add(menuSubmitOption);
        menuFile.add(kdSeparatorFWFile1);
        menuFile.add(rMenuItemSubmit);
        menuFile.add(rMenuItemSubmitAndAddNew);
        menuFile.add(rMenuItemSubmitAndPrint);
        menuFile.add(separatorFile1);
        menuFile.add(MenuItemAttachment);
        menuFile.add(kDSeparator2);
        menuFile.add(menuItemPageSetup);
        menuFile.add(menuItemPrint);
        menuFile.add(menuItemPrintPreview);
        menuFile.add(kDSeparator6);
        menuFile.add(menuItemSendMail);
        menuFile.add(kDSeparator3);
        menuFile.add(menuItemExitCurrent);
        //menuSubmitOption
        menuSubmitOption.add(chkMenuItemSubmitAndAddNew);
        menuSubmitOption.add(chkMenuItemSubmitAndPrint);
        //menuEdit
        menuEdit.add(menuItemCopy);
        menuEdit.add(menuItemEdit);
        menuEdit.add(menuItemRemove);
        menuEdit.add(kDSeparator4);
        menuEdit.add(menuItemReset);
        menuEdit.add(separator1);
        menuEdit.add(menuItemCreateFrom);
        menuEdit.add(menuItemCreateTo);
        menuEdit.add(menuItemCopyFrom);
        menuEdit.add(separatorEdit1);
        menuEdit.add(menuItemEnterToNextRow);
        menuEdit.add(separator2);
        //MenuService
        MenuService.add(MenuItemKnowStore);
        MenuService.add(MenuItemAnwser);
        MenuService.add(SepratorService);
        MenuService.add(MenuItemRemoteAssist);
        //menuView
        menuView.add(menuItemFirst);
        menuView.add(menuItemPre);
        menuView.add(menuItemNext);
        menuView.add(menuItemLast);
        menuView.add(separator3);
        menuView.add(menuItemTraceUp);
        menuView.add(menuItemTraceDown);
        menuView.add(kDSeparator7);
        menuView.add(menuItemLocate);
        //menuBiz
        menuBiz.add(menuItemCancelCancel);
        menuBiz.add(menuItemCancel);
        menuBiz.add(MenuItemVoucher);
        menuBiz.add(menuItemDelVoucher);
        //menuTable1
        menuTable1.add(menuItemAddLine);
        menuTable1.add(menuItemCopyLine);
        menuTable1.add(menuItemInsertLine);
        menuTable1.add(menuItemRemoveLine);
        //menuTool
        menuTool.add(menuItemSendMessage);
        menuTool.add(menuItemMsgFormat);
        menuTool.add(menuItemCalculator);
        menuTool.add(menuItemToolBarCustom);
        //menuWorkflow
        menuWorkflow.add(menuItemStartWorkFlow);
        menuWorkflow.add(separatorWF1);
        menuWorkflow.add(menuItemViewSubmitProccess);
        menuWorkflow.add(menuItemViewDoProccess);
        menuWorkflow.add(MenuItemWFG);
        menuWorkflow.add(menuItemWorkFlowList);
        menuWorkflow.add(separatorWF2);
        menuWorkflow.add(menuItemMultiapprove);
        menuWorkflow.add(menuItemNextPerson);
        menuWorkflow.add(menuItemAuditResult);
        menuWorkflow.add(kDSeparator5);
        menuWorkflow.add(kDMenuItemSendMessage);
        //menuHelp
        menuHelp.add(menuItemHelp);
        menuHelp.add(kDSeparator12);
        menuHelp.add(menuItemRegPro);
        menuHelp.add(menuItemPersonalSite);
        menuHelp.add(helpseparatorDiv);
        menuHelp.add(menuitemProductval);
        menuHelp.add(kDSeparatorProduct);
        menuHelp.add(menuItemAbout);

    }

    /**
     * output initUIToolBarLayout method
     */
    public void initUIToolBarLayout()
    {
        this.toolBar.add(btnAddNew);
        this.toolBar.add(btnCloud);
        this.toolBar.add(btnEdit);
        this.toolBar.add(btnXunTong);
        this.toolBar.add(btnSave);
        this.toolBar.add(kDSeparatorCloud);
        this.toolBar.add(btnReset);
        this.toolBar.add(btnSubmit);
        this.toolBar.add(btnCopy);
        this.toolBar.add(btnRemove);
        this.toolBar.add(btnCancelCancel);
        this.toolBar.add(btnCancel);
        this.toolBar.add(btnAttachment);
        this.toolBar.add(btnAudit);
        this.toolBar.add(btnUnAudit);
        this.toolBar.add(separatorFW1);
        this.toolBar.add(btnPageSetup);
        this.toolBar.add(btnPrint);
        this.toolBar.add(btnPrintPreview);
        this.toolBar.add(separatorFW2);
        this.toolBar.add(btnFirst);
        this.toolBar.add(btnPre);
        this.toolBar.add(btnNext);
        this.toolBar.add(btnLast);
        this.toolBar.add(separatorFW3);
        this.toolBar.add(btnTraceUp);
        this.toolBar.add(btnTraceDown);
        this.toolBar.add(btnWorkFlowG);
        this.toolBar.add(btnSignature);
        this.toolBar.add(btnNumberSign);
        this.toolBar.add(btnViewSignature);
        this.toolBar.add(separatorFW4);
        this.toolBar.add(separatorFW7);
        this.toolBar.add(btnCreateFrom);
        this.toolBar.add(btnCopyFrom);
        this.toolBar.add(btnCreateTo);
        this.toolBar.add(separatorFW5);
        this.toolBar.add(separatorFW8);
        this.toolBar.add(btnAddLine);
        this.toolBar.add(btnCopyLine);
        this.toolBar.add(btnInsertLine);
        this.toolBar.add(btnRemoveLine);
        this.toolBar.add(separatorFW6);
        this.toolBar.add(separatorFW9);
        this.toolBar.add(btnVoucher);
        this.toolBar.add(btnDelVoucher);
        this.toolBar.add(btnAuditResult);
        this.toolBar.add(btnMultiapprove);
        this.toolBar.add(btnWFViewdoProccess);
        this.toolBar.add(btnWFViewSubmitProccess);
        this.toolBar.add(btnNextPerson);


    }

	//Regiester control's property binding.
	private void registerBindings(){
		dataBinder.registerBinding("emergency", boolean.class, this.chkemergency, "selected");
		dataBinder.registerBinding("creator", com.kingdee.eas.base.permission.UserInfo.class, this.prmtCreator, "data");
		dataBinder.registerBinding("createTime", java.sql.Timestamp.class, this.pkCreateTime, "value");
		dataBinder.registerBinding("lastUpdateUser", com.kingdee.eas.base.permission.UserInfo.class, this.prmtLastUpdateUser, "data");
		dataBinder.registerBinding("lastUpdateTime", java.sql.Timestamp.class, this.pkLastUpdateTime, "value");
		dataBinder.registerBinding("CU", com.kingdee.eas.basedata.org.CtrlUnitInfo.class, this.prmtCU, "data");
		dataBinder.registerBinding("number", String.class, this.txtNumber, "text");
		dataBinder.registerBinding("bizDate", java.util.Date.class, this.pkBizDate, "value");
		dataBinder.registerBinding("description", String.class, this.txtDescription, "text");
		dataBinder.registerBinding("auditor", com.kingdee.eas.base.permission.UserInfo.class, this.prmtAuditor, "data");
		dataBinder.registerBinding("status", com.kingdee.eas.xr.app.XRBillStatusEnum.class, this.comboStatus, "selectedItem");
		dataBinder.registerBinding("bizStatus", com.kingdee.eas.xr.app.XRBizActionEnum.class, this.comboBizStatus, "selectedItem");
		dataBinder.registerBinding("auditTime", java.sql.Timestamp.class, this.pkAuditTime, "value");
		dataBinder.registerBinding("title", String.class, this.txttitle, "text");
		dataBinder.registerBinding("projectNam", String.class, this.txtprojectNam, "text");
		dataBinder.registerBinding("preDepartment", com.kingdee.eas.basedata.org.AdminOrgUnitInfo.class, this.prmtpreDepartment, "data");
		dataBinder.registerBinding("preCompany", com.kingdee.eas.basedata.org.CompanyOrgUnitInfo.class, this.prmtpreCompany, "data");
		dataBinder.registerBinding("prePerson", com.kingdee.eas.basedata.person.PersonInfo.class, this.prmtprePerson, "data");
		dataBinder.registerBinding("budget", java.math.BigDecimal.class, this.txtbudget, "value");
		dataBinder.registerBinding("startTime", java.util.Date.class, this.pkstartTime, "value");
		dataBinder.registerBinding("endTime", java.sql.Time.class, this.endTime, "value");
		dataBinder.registerBinding("attributeCompany", com.kingdee.eas.basedata.org.CompanyOrgUnitInfo.class, this.prmtattributeCompany, "data");
		dataBinder.registerBinding("reason", String.class, this.txtreason, "text");
		dataBinder.registerBinding("comment", String.class, this.txtcomment, "text");
		dataBinder.registerBinding("overTime", java.util.Date.class, this.pkoverTime, "value");		
	}
	//Regiester UI State
	private void registerUIState(){		
	}
	public String getUIHandlerClassName() {
	    return "com.kingdee.eas.custom.lxsq.app.ProjectApplicationEditUIHandler";
	}
	public IUIActionPostman prepareInit() {
		IUIActionPostman clientHanlder = super.prepareInit();
		if (clientHanlder != null) {
			RequestContext request = new RequestContext();
    		request.setClassName(getUIHandlerClassName());
			clientHanlder.setRequestContext(request);
		}
		return clientHanlder;
    }
	
	public boolean isPrepareInit() {
    	return false;
    }
    protected void initUIP() {
        super.initUIP();
    }


    /**
     * output onShow method
     */
    public void onShow() throws Exception
    {
        super.onShow();
        this.txttitle.requestFocusInWindow();
    }

	
	

    /**
     * output setDataObject method
     */
    public void setDataObject(IObjectValue dataObject)
    {
        IObjectValue ov = dataObject;        	    	
        super.setDataObject(ov);
        this.editData = (com.kingdee.eas.custom.lxsq.ProjectApplicationInfo)ov;
    }
    protected void removeByPK(IObjectPK pk) throws Exception {
    	IObjectValue editData = this.editData;
    	super.removeByPK(pk);
    	recycleNumberByOrg(editData,"NONE",editData.getString("number"));
    }
    
    protected void recycleNumberByOrg(IObjectValue editData,String orgType,String number) {
        if (!StringUtils.isEmpty(number))
        {
            try {
            	String companyID = null;            
            	com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID =com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}				
				if (!StringUtils.isEmpty(companyID) && iCodingRuleManager.isExist(editData, companyID) && iCodingRuleManager.isUseIntermitNumber(editData, companyID)) {
					iCodingRuleManager.recycleNumber(editData,companyID,number);					
				}
            }
            catch (Exception e)
            {
                handUIException(e);
            }
        }
    }
    protected void setAutoNumberByOrg(String orgType) {
    	if (editData == null) return;
		if (editData.getNumber() == null) {
            try {
            	String companyID = null;
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID = com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}
				com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
		        if (iCodingRuleManager.isExist(editData, companyID)) {
		            if (iCodingRuleManager.isAddView(editData, companyID)) {
		            	editData.setNumber(iCodingRuleManager.getNumber(editData,companyID));
		            }
	                txtNumber.setEnabled(false);
		        }
            }
            catch (Exception e) {
                handUIException(e);
                this.oldData = editData;
                com.kingdee.eas.util.SysUtil.abort();
            } 
        } 
        else {
            if (editData.getNumber().trim().length() > 0) {
                txtNumber.setText(editData.getNumber());
            }
        }
    }

    /**
     * output loadFields method
     */
    public void loadFields()
    {
        		setAutoNumberByOrg("NONE");
        dataBinder.loadFields();
    }
		protected void setOrgF7(KDBizPromptBox f7,com.kingdee.eas.basedata.org.OrgType orgType) throws Exception
		{
			com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer oufip = new com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer(orgType);
			oufip.getModel().setIsCUFilter(true);
			f7.setFilterInfoProducer(oufip);
		}

    /**
     * output storeFields method
     */
    public void storeFields()
    {
		dataBinder.storeFields();
    }

	/**
	 * ????????У??
	 */
	protected void registerValidator() {
    	getValidateHelper().setCustomValidator( getValidator() );
		getValidateHelper().registerBindProperty("emergency", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("creator", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("createTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("lastUpdateUser", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("lastUpdateTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("CU", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("number", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("bizDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("description", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("auditor", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("status", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("bizStatus", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("auditTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("title", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("projectNam", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("preDepartment", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("preCompany", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("prePerson", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("budget", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("startTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("endTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("attributeCompany", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("reason", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("comment", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("overTime", ValidateHelper.ON_SAVE);    		
	}



    /**
     * output setOprtState method
     */
    public void setOprtState(String oprtType)
    {
        super.setOprtState(oprtType);
        if (STATUS_ADDNEW.equals(this.oprtState)) {
        } else if (STATUS_EDIT.equals(this.oprtState)) {
        } else if (STATUS_VIEW.equals(this.oprtState)) {
        } else if (STATUS_FINDVIEW.equals(this.oprtState)) {
        }
    }

    /**
     * output getSelectors method
     */
    public SelectorItemCollection getSelectors()
    {
        SelectorItemCollection sic = new SelectorItemCollection();
		String selectorAll = System.getProperty("selector.all");
		if(StringUtils.isEmpty(selectorAll)){
			selectorAll = "true";
		}
        sic.add(new SelectorItemInfo("emergency"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("creator.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("creator.id"));
        	sic.add(new SelectorItemInfo("creator.number"));
        	sic.add(new SelectorItemInfo("creator.name"));
		}
        sic.add(new SelectorItemInfo("createTime"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("lastUpdateUser.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("lastUpdateUser.id"));
        	sic.add(new SelectorItemInfo("lastUpdateUser.number"));
        	sic.add(new SelectorItemInfo("lastUpdateUser.name"));
		}
        sic.add(new SelectorItemInfo("lastUpdateTime"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("CU.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("CU.id"));
        	sic.add(new SelectorItemInfo("CU.number"));
        	sic.add(new SelectorItemInfo("CU.name"));
		}
        sic.add(new SelectorItemInfo("number"));
        sic.add(new SelectorItemInfo("bizDate"));
        sic.add(new SelectorItemInfo("description"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("auditor.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("auditor.id"));
        	sic.add(new SelectorItemInfo("auditor.number"));
        	sic.add(new SelectorItemInfo("auditor.name"));
		}
        sic.add(new SelectorItemInfo("status"));
        sic.add(new SelectorItemInfo("bizStatus"));
        sic.add(new SelectorItemInfo("auditTime"));
        sic.add(new SelectorItemInfo("title"));
        sic.add(new SelectorItemInfo("projectNam"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("preDepartment.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("preDepartment.id"));
        	sic.add(new SelectorItemInfo("preDepartment.number"));
        	sic.add(new SelectorItemInfo("preDepartment.name"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("preCompany.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("preCompany.id"));
        	sic.add(new SelectorItemInfo("preCompany.number"));
        	sic.add(new SelectorItemInfo("preCompany.name"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("prePerson.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("prePerson.id"));
        	sic.add(new SelectorItemInfo("prePerson.number"));
        	sic.add(new SelectorItemInfo("prePerson.name"));
		}
        sic.add(new SelectorItemInfo("budget"));
        sic.add(new SelectorItemInfo("startTime"));
        sic.add(new SelectorItemInfo("endTime"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("attributeCompany.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("attributeCompany.id"));
        	sic.add(new SelectorItemInfo("attributeCompany.number"));
        	sic.add(new SelectorItemInfo("attributeCompany.name"));
		}
        sic.add(new SelectorItemInfo("reason"));
        sic.add(new SelectorItemInfo("comment"));
        sic.add(new SelectorItemInfo("overTime"));
        return sic;
    }        
    	

    /**
     * output actionSubmit_actionPerformed method
     */
    public void actionSubmit_actionPerformed(ActionEvent e) throws Exception
    {
        super.actionSubmit_actionPerformed(e);
    }
    	

    /**
     * output actionUnAudit_actionPerformed method
     */
    public void actionUnAudit_actionPerformed(ActionEvent e) throws Exception
    {
        super.actionUnAudit_actionPerformed(e);
    }
	public RequestContext prepareActionSubmit(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionSubmit(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionSubmit() {
    	return false;
    }
	public RequestContext prepareActionUnAudit(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionUnAudit(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionUnAudit() {
    	return false;
    }

    /**
     * output getMetaDataPK method
     */
    public IMetaDataPK getMetaDataPK()
    {
        return new MetaDataPK("com.kingdee.eas.custom.lxsq.client", "ProjectApplicationEditUI");
    }
    /**
     * output isBindWorkFlow method
     */
    public boolean isBindWorkFlow()
    {
        return true;
    }

    /**
     * output getEditUIName method
     */
    protected String getEditUIName()
    {
        return com.kingdee.eas.custom.lxsq.client.ProjectApplicationEditUI.class.getName();
    }

    /**
     * output getBizInterface method
     */
    protected com.kingdee.eas.framework.ICoreBase getBizInterface() throws Exception
    {
        return com.kingdee.eas.custom.lxsq.ProjectApplicationFactory.getRemoteInstance();
    }

    /**
     * output createNewData method
     */
    protected IObjectValue createNewData()
    {
        com.kingdee.eas.custom.lxsq.ProjectApplicationInfo objectValue = new com.kingdee.eas.custom.lxsq.ProjectApplicationInfo();
        objectValue.setCreator((com.kingdee.eas.base.permission.UserInfo)(com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentUser()));		
        return objectValue;
    }


    	protected String getTDFileName() {
    	return "/bim/custom/lxsq/ProjectApplication";
	}
    protected IMetaDataPK getTDQueryPK() {
    	return new MetaDataPK("com.kingdee.eas.custom.lxsq.app.ProjectApplicationQuery");
	}
    
        
					protected void beforeStoreFields(ActionEvent arg0) throws Exception {
		if (com.kingdee.bos.ui.face.UIRuleUtil.isNull(txtNumber.getText())) {
			throw new com.kingdee.eas.common.EASBizException(com.kingdee.eas.common.EASBizException.CHECKBLANK,new Object[] {"单据编号"});
		}
		if (com.kingdee.bos.ui.face.UIRuleUtil.isNull(txttitle.getText())) {
			throw new com.kingdee.eas.common.EASBizException(com.kingdee.eas.common.EASBizException.CHECKBLANK,new Object[] {"标题"});
		}
		if (com.kingdee.bos.ui.face.UIRuleUtil.isNull(txtprojectNam.getText())) {
			throw new com.kingdee.eas.common.EASBizException(com.kingdee.eas.common.EASBizException.CHECKBLANK,new Object[] {"项目名称"});
		}
		if (com.kingdee.bos.ui.face.UIRuleUtil.isNull(txtbudget.getValue())) {
			throw new com.kingdee.eas.common.EASBizException(com.kingdee.eas.common.EASBizException.CHECKBLANK,new Object[] {"项目预算"});
		}
		if (com.kingdee.bos.ui.face.UIRuleUtil.isNull(txtreason.getText())) {
			throw new com.kingdee.eas.common.EASBizException(com.kingdee.eas.common.EASBizException.CHECKBLANK,new Object[] {"事由及要求"});
		}
			super.beforeStoreFields(arg0);
		}

    /**
     * output getDetailTable method
     */
    protected KDTable getDetailTable() {        
        return null;
	}
    /**
     * output applyDefaultValue method
     */
    protected void applyDefaultValue(IObjectValue vo) {        
    }        
	protected void setFieldsNull(com.kingdee.bos.dao.AbstractObjectValue arg0) {
		super.setFieldsNull(arg0);
		arg0.put("number",null);
	}

}